-- at which fraction of the remaining animation time to enable the ragdoll, randomizes between min and max
local ragdoll_enable_min_f = 0
local ragdoll_enable_max_f = 0.35

function CopMovement:delayed_force_ragdoll()
	self._ragdoll_t = nil
	for _, action in ipairs(self._active_actions) do
		if action and action.force_ragdoll then
			action:force_ragdoll()
		end
	end
end

local ids_base = Idstring("base")
function CopMovement:anim_clbk_force_ragdoll()
	local relative_time = self._machine:segment_relative_time(ids_base)
	if relative_time <= 0 then
		return self:delayed_force_ragdoll()
	end
	local real_time = self._machine:segment_real_time(ids_base)
	local anim_len = real_time / relative_time
	local anim_time_left = anim_len - real_time
	self._ragdoll_t = anim_time_left * (ragdoll_enable_min_f + math.random() * (ragdoll_enable_max_f - ragdoll_enable_min_f))
	DelayedCalls:Add(tostring(self._unit:key()) .. "_delayed_ragdoll", self._ragdoll_t, function ()
		if self._ragdoll_t and alive(self._unit) then
			self:delayed_force_ragdoll()
		end
	end)
end

Hooks:PreHook(CopMovement, "pre_destroy", "pre_destroy_ragdoll", function (self)
	if self._ragdoll_t then
		self:delayed_force_ragdoll()
	end
end)
